import { APIRegistrar, DocumentModuleEntry, EventsRegistrar, IndexedField, IndexedFieldsRegistrar } from './api/lad-api-utils';
export interface LadGlobal {
    publicServerEventsRegistrar?: EventsRegistrar;
    publicServerEventsRegistry?: Set<string>;
    privateServerEventsRegistrar?: EventsRegistrar;
    privateServerEventsRegistry?: Set<string>;
    registeredModules?: DocumentModuleEntry[];
    registrar?: APIRegistrar;
    indexedFieldsRegistry?: {
        [key: string]: IndexedField;
    };
    indexedFieldsRegistrar?: IndexedFieldsRegistrar;
}
export declare let LAD_GLOBAL: LadGlobal;
export declare function setRegistrar(r: APIRegistrar): void;
export declare function setIndexedFieldsRegistrar(r: IndexedFieldsRegistrar): void;
export declare function setPublicServerEventsRegistrar(r: EventsRegistrar): void;
export declare function findEntry(name: string): DocumentModuleEntry;
export * from './api/lad-api-utils';
export * from './decorators';
export * from './models/system-document.model';
export * from './models/lad-account.model';
export * from './models/lad-account-control.model';
export * from './models/lad-account-security.model';
export * from './server/lad-document-service';
export * from './models/lad-related-document';
export * from './models/lad-date';
export * from './models/lad-uploaded-asset';
export * from './models/lad-geojson-object';
export * from './models/lad-number-increment';
export * from './server/lad-server-config';
export * from './utils/errors';
export * from './utils/date-helper';
export * from './mircroservices/lad-microservice';
