"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
exports.LAD_GLOBAL = globalThis;
exports.LAD_GLOBAL.registeredModules = [];
exports.LAD_GLOBAL.indexedFieldsRegistry = {}; // registry {propertyName, modelName} for select values
// for sse events
exports.LAD_GLOBAL.privateServerEventsRegistry = new Set();
exports.LAD_GLOBAL.publicServerEventsRegistry = new Set();
// --- public functions:
function setRegistrar(r) {
    exports.LAD_GLOBAL.registrar = r;
    for (var _i = 0, _a = exports.LAD_GLOBAL.registeredModules; _i < _a.length; _i++) {
        var m = _a[_i];
        for (var _b = 0, _c = m.api; _b < _c.length; _b++) {
            var apiFn = _c[_b];
            try {
                r(m, apiFn);
            }
            catch (e) {
                console.error(e);
            }
        }
    }
}
exports.setRegistrar = setRegistrar;
function setIndexedFieldsRegistrar(r) {
    exports.LAD_GLOBAL.indexedFieldsRegistrar = r;
    for (var _i = 0, _a = Object.values(exports.LAD_GLOBAL.indexedFieldsRegistry); _i < _a.length; _i++) {
        var i = _a[_i];
        try {
            r(i.modelName, i.propertyKey);
        }
        catch (e) {
            console.error(e);
        }
    }
}
exports.setIndexedFieldsRegistrar = setIndexedFieldsRegistrar;
function setPublicServerEventsRegistrar(r) {
    exports.LAD_GLOBAL.publicServerEventsRegistrar = r;
    exports.LAD_GLOBAL.publicServerEventsRegistry.forEach(function (channel) {
        try {
            r(channel);
        }
        catch (e) {
            console.error(e);
        }
    });
}
exports.setPublicServerEventsRegistrar = setPublicServerEventsRegistrar;
// export function setPrivateServerEventsRegistrar(r: EventsRegistrar) {
//     LAD_GLOBAL.privateServerEventsRegistrar = r;
//     LAD_GLOBAL.privateServerEventsRegistry.forEach(channel => {
//         try {
//             r(channel);
//         } catch (e) {
//             console.error(e);
//         }
//     });
// }
function findEntry(name) {
    for (var _i = 0, _a = exports.LAD_GLOBAL.registeredModules; _i < _a.length; _i++) {
        var m = _a[_i];
        if (m.model.name === name) {
            return m;
        }
    }
}
exports.findEntry = findEntry;
tslib_1.__exportStar(require("./api/lad-api-utils"), exports);
tslib_1.__exportStar(require("./decorators"), exports);
tslib_1.__exportStar(require("./models/system-document.model"), exports);
tslib_1.__exportStar(require("./models/lad-account.model"), exports);
tslib_1.__exportStar(require("./models/lad-account-control.model"), exports);
tslib_1.__exportStar(require("./models/lad-account-security.model"), exports);
tslib_1.__exportStar(require("./models/lad-related-document"), exports);
tslib_1.__exportStar(require("./models/lad-date"), exports);
tslib_1.__exportStar(require("./models/lad-geojson-object"), exports);
tslib_1.__exportStar(require("./models/lad-number-increment"), exports);
tslib_1.__exportStar(require("./server/lad-server-config"), exports);
tslib_1.__exportStar(require("./utils/errors"), exports);
tslib_1.__exportStar(require("./utils/date-helper"), exports);
tslib_1.__exportStar(require("./mircroservices/lad-microservice"), exports);
//# sourceMappingURL=index.js.map