import { LadDate } from "./lad-date";
export interface ArchiveInfo {
    archivedBy: string;
    archivedOn: LadDate;
}
export interface DeleteInfo {
    deletedOnLadDate: LadDate;
    deletedBy: string;
}
export interface NamedObject {
    name: string;
}
export declare class SystemHeader {
    type: string;
    systemId?: string;
    isNew: boolean;
    createdOnLadDate: LadDate;
    createdBy?: string;
    updatedOnLadDate: LadDate;
    updatedBy?: string;
    previousVersionId?: string;
    versionId?: any;
    currentVersion?: boolean;
    archiveInfo?: ArchiveInfo;
    deleted?: boolean;
    deleteInfo?: DeleteInfo;
    accountVerified?: boolean;
    __?: any;
    constructor(type: string, systemId?: string);
}
export declare const MONGODB_DOLLAR_UPDATE_OPERATIONS: string[];
export declare class SystemDocument {
    _id?: string;
    documentId: string;
    systemHeader: SystemHeader;
    static __archiveDocument(original: any, now: LadDate, updaterId: any): SystemDocument;
    static __getDeleteUpdateInfo(deleterId: any): {
        $set: {};
    };
    static __getUpdateInfo(original: any, updatedDocumentOrig: any, updaterId: any): {
        archived: SystemDocument;
        updateInfo: any;
    };
    constructor(type: string, systemId?: string);
}
