import { APIFunction, APIFunctionTypes, NamedObject } from "..";
export interface UpdateOptions {
    verifyAccountStatusAtSystemHeader?: boolean;
    session?: any;
    noProcessors?: boolean;
}
export interface LadFindOptions {
    session?: any;
    toFetchRelatedDocuments?: string[];
    sort?: any;
    limit?: any;
    projection?: any;
    includeDeleted?: boolean;
    pageNumber?: number;
    nPerPage?: number;
}
export interface UpdatableDocumentSystemHeader {
    type: string | NamedObject;
}
export interface UpdatableDocument {
    documentId: string;
    systemHeader: UpdatableDocumentSystemHeader;
}
export interface LadDocumentService {
    addProcessorFn(systemType: string, fn: APIFunction, fnType: APIFunctionTypes): any;
    deleteDocument(systemType: string, documentId: string, deleterId: string): Promise<any>;
    upsert(d: UpdatableDocument | UpdatableDocument[], updaterId: string, updateOptions?: UpdateOptions): Promise<any>;
    find(systemType: any, filter: any, options?: LadFindOptions): Promise<any[]>;
    findOne(systemType: any, filter: any, options?: LadFindOptions): Promise<any>;
    getAllValuesInFieldAsSet(systemType: string, fieldName: string, $match?: any): Promise<any>;
    count(systemType: any, filter: any): Promise<Number>;
}
export interface LadRedisService {
    get(key: string): Promise<any>;
    set(key: any, json: any): any;
    del(key: any): Promise<any>;
    getRedisClient: any;
}
