"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// Http ready exceptions or errors. As much as possible avoid creating generic errors. Add more if necessary.
var ServerError = /** @class */ (function (_super) {
    tslib_1.__extends(ServerError, _super);
    function ServerError(msg) {
        var _this = _super.call(this, msg ? msg : 'An error occurred at server.') || this;
        _this.httpStatus = 500;
        _this.name = 'ServerError';
        return _this;
    }
    return ServerError;
}(Error));
exports.ServerError = ServerError;
var NotFoundError = /** @class */ (function (_super) {
    tslib_1.__extends(NotFoundError, _super);
    function NotFoundError(msg) {
        var _this = _super.call(this, msg ? msg : 'Not found.') || this;
        _this.httpStatus = 404;
        _this.name = 'NotFoundError';
        return _this;
    }
    return NotFoundError;
}(Error));
exports.NotFoundError = NotFoundError;
var InvalidRequestError = /** @class */ (function (_super) {
    tslib_1.__extends(InvalidRequestError, _super);
    function InvalidRequestError(msg) {
        var _this = _super.call(this, msg ? msg : 'Invalid request.') || this;
        _this.httpStatus = 400;
        _this.name = 'InvalidRequestError';
        return _this;
    }
    return InvalidRequestError;
}(Error));
exports.InvalidRequestError = InvalidRequestError;
var ForbiddenError = /** @class */ (function (_super) {
    tslib_1.__extends(ForbiddenError, _super);
    function ForbiddenError(msg) {
        var _this = _super.call(this, msg ? msg : 'Forbidden.') || this;
        _this.httpStatus = 403;
        _this.name = 'ForbiddenError';
        return _this;
    }
    return ForbiddenError;
}(Error));
exports.ForbiddenError = ForbiddenError;
var UnauthorizedError = /** @class */ (function (_super) {
    tslib_1.__extends(UnauthorizedError, _super);
    function UnauthorizedError(msg) {
        var _this = _super.call(this, msg ? msg : 'Unauthorized.') || this;
        _this.httpStatus = 401;
        _this.name = 'UnauthorizedError';
        return _this;
    }
    return UnauthorizedError;
}(Error));
exports.UnauthorizedError = UnauthorizedError;
var NotImplementedError = /** @class */ (function (_super) {
    tslib_1.__extends(NotImplementedError, _super);
    function NotImplementedError(msg) {
        var _this = _super.call(this, msg ? msg : 'Not implemented.') || this;
        _this.httpStatus = 501;
        _this.name = 'NotImplementedError';
        return _this;
    }
    return NotImplementedError;
}(Error));
exports.NotImplementedError = NotImplementedError;
var TooManyRequestsError = /** @class */ (function (_super) {
    tslib_1.__extends(TooManyRequestsError, _super);
    function TooManyRequestsError(msg) {
        var _this = _super.call(this, msg ? msg : 'Too Many Requests.') || this;
        _this.httpStatus = 429;
        _this.name = 'TooManyRequestsError';
        return _this;
    }
    return TooManyRequestsError;
}(Error));
exports.TooManyRequestsError = TooManyRequestsError;
//# sourceMappingURL=errors.js.map